int i;

temp_ls_update_pk = ( LSUpdatePk *) op_prg_mem_alloc( sizeof(LSUpdatePk) );
memset( temp_ls_update_pk, 0, sizeof(LSUpdatePk) );

temp_ls_update_pk->OspfPkHeader.Version = VERSION;
temp_ls_update_pk->OspfPkHeader.Type = LSUPDATEPK;
temp_ls_update_pk->OspfPkHeader.PacketLength = sizeof(LSUpdatePk);
op_prg_mem_copy(temp_ls_update_pk->OspfPkHeader.RouterId, &(RouterId), 
				sizeof(IPAddress) );
temp_ls_update_pk->OspfPkHeader.AreaId = AreaId;
temp_ls_update_pk->OspfPkHeader.CheckSum = LSUpdatePkCheckSum;
temp_ls_update_pk->OspfPkHeader.AuType = NONE;
temp_ls_update_pk->OspfPkHeader.Authentication = 0;

if(Prev_sended_ResLsaSeqNo <= res_ls_seq_no)
	temp_ls_update_pk->NoOfAdvs++;
if(Prev_sended_RRALsaSeqNo <= rra_ls_seq_no)
	temp_ls_update_pk->NoOfAdvs++;
if(Prev_sended_NetworkLsaSeqNo <= network_ls_seq_no)
	temp_ls_update_pk->NoOfAdvs++;
if(Prev_sended_SummaryLsaSeqNo <= summary_ls_seq_no)
	temp_ls_update_pk->NoOfAdvs++;
if(Prev_sended_RouterLsaSeqNo <= router_ls_seq_no)
	temp_ls_update_pk->NoOfAdvs++;
if(Prev_sended_GrpmbrLsaSeqNo <= grpmbr_ls_seq_no)
	temp_ls_update_pk->NoOfAdvs++;

op_prg_mem_copy( temp_ls_update_pk->ResLinkStateAdv, ResourceLsa, 
				 sizeof(reslsa) );
op_prg_mem_copy( temp_ls_update_pk->RraLinkStateAdv, RRALsa, 
				 sizeof(rralsa) );
op_prg_mem_copy( temp_ls_update_pk->GrpmbrLinkStateAdv, GrpMbrLsa, 
				 sizeof(grpmbrlsa) );
op_prg_mem_copy( temp_ls_update_pk->RouterLinkStateAdv, RouterLsa, 
				 sizeof(RouterLinkAdv) );
op_prg_mem_copy( temp_ls_update_pk->NetworkLinkStateAdv, NetworkLsa, 
				 sizeof(NetworkLinkAdv) );
op_prg_mem_copy( temp_ls_update_pk->SummaryLinkStateAdv, SummaryLsa, 
				 sizeof(SummaryLinkAdv) );

LsUpdatePkptr = op_pk_create_fmt("lsupdate_pkfmt");
op_pk_nfd_set( LsUpdatePkptr, "Lsupdate", temp_ls_update_pk, op_prg_mem_alloc,
			   op_prg_mem_free, sizeof(LSUpdatePk) );

ipdgramptr = op_pk_create_fmt("ipdgram_pkfmt");
op_pk_nfd_set( ipdgramptr, "data", LsUpdatePkptr );
op_pk_nfd_set( ipdgramptr, "ProtocolId", OspfPk );
op_pk_nfd_set( ipdgramptr, "dest_net", AllSPFRoutersNetNum );
op_pk_nfd_set( ipdgramptr, "dest_node", AllSPFRoutersNetNode );

op_pk_send( ipdgramptr, IPSTREAM );
